/**
 * Proiectarea Algoritmilor, 2013
 * Lab 9: Arbori minimi de acoperire
 *
 * @author 	Alexandru Tudorica
 * @email	tudalex@gmail.com
 */

#include "Graph.h"

static inline void sort_pair(std::pair < int, int> &p) {
	if (p.first > p.second)
		std::swap(p.first, p.second);
}

/*
 * Algoritmul lui Prim
 */
std::vector< std::pair<int, int> > prim(Graph &g) {

	std::vector<Node*> nodes = g.get_nodes();
	std::vector < int > cost(nodes.size(), MAX_VALUE);
	std::vector < int > parent(nodes.size(), -1);
	std::vector < std::pair <Node*, int> > Q;
	std::vector< std::pair <int, int> > ama;
	unsigned int source = 0;
	/*
	 * TODO
	 * initializam cost si parinte
	 *
	 * Hint:
	 * bool g.existEdgeBetween(Node, Node)
	 * int g.getCostBetween(Node, Node)
	 */

	

	/*
	 * TODO
	 * aflati costul minim al unei muchii de la AMA catre nod
	 * incercati sa relaxati muchiile
	 * daca o muchie poate fi relaxata si nodul nu este deja in AMA => ea va fi updatata in Q
	 */

	

	return ama;
}

static int get_mul(int *mul, int x) {
	
}
static void join_mul(int *mul, int x, int y) {
	
}

std::vector< std::pair<int, int> > kruskal(Graph &g) {
	std::vector<Node*> nodes = g.get_nodes();
	std::vector< std::pair<int, int> > edges = g.get_all_edges();
	std::vector< std::pair<int, int> > ama;
	int *multimi = new int[g.node_count()];
	/*
	 * TODO
	 * Construiti o lista de muchii cu tot cu cost
	 * Sortati lista de muchii dupa costul lor
	 *
	 * Initializati vectorul multimi
	 *
	 * HINT: std::sort, std::vector, std::make_pair
	 */

	

	/*
	 * TODO
	 * Parcurgeti muchiile in ordine
	 * Pe cele care intra in AMA le bagati in vectorul ama
	 */

	

	delete multimi;
	return ama;
}

const int maze_size = 5;

void initMaze(Graph &g) {

	for (int i = 0; i < maze_size*maze_size; ++i)
		g.insert_node(new Node(i));

	/*
	 * TODO
	 * Construieste legaturile intre nodurile din labirint
	 * Nodul de la pozitia (i,j) va avea id-ul i*maze_size+j
	 *
	 * ATENTIE SA NU IESITI DIN LABIRINT
	 */
	

}

void printMaze(std::vector <std::pair<int, int> >&edges) {
	char maze[maze_size*2+1][maze_size*2+1];
	const int dx[] = {0, 0, -1, 1};
	const int dy[] = {1, -1, 0, 0};
	memset(maze, 0, sizeof(maze));
	for (int i = 0; i < maze_size; ++i)
		for (int j = 0; j < maze_size; ++j) {
			maze[2*i+1][2*j+1] = 1;
			for (int k = 0; k < 4; ++k) {
				int x = i+dx[k];
				int y = j+dy[k];
				if (std::find(edges.begin(), edges.end(), std::make_pair(i*maze_size+j,x*maze_size+y)) != edges.end() ||
						std::find(edges.begin(), edges.end(), std::make_pair(x*maze_size+y,i*maze_size+j)) != edges.end())
					maze[2*i+1+dx[k]][2*j+1+dy[k]] = 1;
			}

		}
	for (int i = 0; i < 2*maze_size+1; ++i, printf("\n"))
		for (int j = 0; j < 2*maze_size+1; ++j)
			if (!maze[i][j])
				printf("#");
			else
				printf("_");

}

void randomizedAMA() {
	Graph g;
	initMaze(g);
	std::vector < std::pair <int, int> > edges;

	/*
	 * TODO
	 * Aplica un algorithm de AMA cu alegere randomizata
	 */

	

	printMaze(edges);
}

int main( int argc, char* argv[] )
{
	/* Deschidem fisierul de intrare */

	const char *fisiere[] = {"date1.in", "date2.in"};
	for (int test = 0; test < 2; ++test) {
		if (freopen(fisiere[test], "r", stdin) == NULL)
			return 1;

		/* Cream un graf, ii incarcam muchiile din fisier */
		Graph g;
		std::cin >> g;
		std::cout << g << std::endl;
		int sum;
		std::vector<Node*> nodes = g.get_nodes();
		std::vector < std::pair <int, int> > edges;
		std::vector < std::pair <int, int> >::iterator e_it;
		edges = prim(g);
		sum = 0;
		for (e_it = edges.begin(); e_it != edges.end(); ++e_it) {
			sort_pair(*e_it);
			sum+=g.get_cost_between(nodes[e_it->first], nodes[e_it->second]);
		}
		sort(edges.begin(), edges.end());
		std::cout <<"Kruskal: "<<std::endl<<edges<<"Costul total: "<<sum<<std::endl;

		edges = kruskal(g);
		sum = 0;
		for (e_it = edges.begin(); e_it != edges.end(); ++e_it) {
			sort_pair(*e_it);
			sum+=g.get_cost_between(nodes[e_it->first], nodes[e_it->second]);
		}
		sort(edges.begin(), edges.end());
		std::cout <<"Prim: "<<std::endl<<edges<<"Costul total: "<<sum<<std::endl;
	}
	randomizedAMA();
	return 0;
}

