/**
 * Proiectarea Algoritmilor, 2013
 * Lab 9: Arbori minimi de acoperire
 *
 * @author 	Alexandru Tudorica
 * @email	tudalex@gmail.com
 */

#ifndef GRAPH_H
#define GRAPH_H

#include"Util.h"
#include"Node.h"

#define MAX_VALUE 9999

class Graph {

	std::vector<Node*> Nodes;
	std::vector< std::vector< std::pair<Node*, int> > > Edges;
	std::vector< std::pair <int, int> > all_edges;

	void check_node(Node& node) const;

	public:

	Graph();
	virtual ~Graph();

	uint node_count() const;

	void insert_node(Node* node);
	void insert_edge(Node* node1, Node* node2, int cost);

	std::vector<Node*>& get_nodes();
	std::vector<std::pair<Node*, int> >& get_edges(Node& node);
	std::vector< std::pair <int, int > >& get_all_edges();

	bool exists_edge_between(Node* node1, Node* node2);
	int get_cost_between(Node* node1, Node* node2);
	void reset();

	friend std::istream& operator>> (std::istream& in , Graph& node );
	friend std::ostream& operator<< (std::ostream& out, Graph& node );

};

#endif
